/** 
 * @(#)Ausstoss.java
 */

/**
 * @author Didier Gutacker
 * @version 1.0, 12.08.97 
 */

import java.awt.*;
import java.applet.*;

class Ausstoss extends Frame {

   /** Panel */
   
   Panel Schalter;
   Panel Scrollings[];

   /** Label */

   private Label startknotenqueue;
   private Label[] queuelabel;
   private Label[] infos;   
 
  /** Ablesevariablen */

   private int startrate;
   private int[] queueraten;
   private int queuezahl = 1;
 
   /** Scrollbars */

   private Scrollbar startknotensbar;
   private Scrollbar[] sbar;

  /** Buttons */

   private Button ok;
   private Button cancel;

  /** Hilfsvariablen */

   private Font font = new Font("Dialog",Font.BOLD,15);
   private Oberflaeche puCl;
   private Netzknoten akt_knoten;

   /** Konstruktur. Baut neues Fenster mit Scrollbars zur Auswahl der Ausstossraten auf */

   public Ausstoss(Oberflaeche publicClass,Netzknoten akt) {

      puCl = publicClass;
      startrate = puCl.NetzwerkCanvas.gib_ausstoss();
      akt_knoten = akt;

      /* Anzahl der anzuzeigenden Scrollbars bestimmen : Anzahl Queues in Netzknoten plus
         Eingangsrate im Startknoten */

      queuezahl = akt_knoten.gib_queue_anzahl()+1; 

      queueraten = new int[(queuezahl-1)];

      /* Momentanen Ausstoss der Queues auslesen  */

      for ( int i = 0; i < (queuezahl-1); i++)
         queueraten[i]=puCl.NetzwerkCanvas.gib_queueraten(i);

      setTitle("Queues-rate setting");
      setLayout(new GridLayout((queuezahl+4),1));
      setFont(font);
    
      Scrollings = new Panel[(queuezahl+3)];
      Schalter = new Panel();

      sbar = new Scrollbar[(queuezahl-1)];
      queuelabel = new Label[(queuezahl-1)];

      Scrollings[0] = new Panel();
      Scrollings[0].setLayout(new GridLayout(3,1));

      infos = new Label[3];

      infos[0] = new Label("Informations about the viewed node : ",Label.CENTER);

      infos[1] =  new Label("");   

      infos[2] = new Label("node-id : "+akt_knoten.gib_id()+"  node-status : "+akt_knoten.gib_zustand()+"  Number of queues : "+akt_knoten.gib_queue_anzahl(),Label.CENTER);

      for ( int i = 0; i < 3; i++)
         Scrollings[0].add(infos[i]);

      Scrollings[1] = new Panel();
      Scrollings[1].setLayout(new GridLayout(3,1));

      infos[0] = new Label("");

      infos[1] = new Label("This affects the start-node.",Label.CENTER);

      infos[2] = new Label("");

      for ( int i = 0; i < 3; i++)
         Scrollings[1].add(infos[i]);

      Panel hilf = new Panel();
      hilf.setLayout(new GridLayout(2,1));

      hilf.add(startknotenqueue = new Label("entrance-rate start-node : "+startrate+"    ",Label.CENTER));
      hilf.add(startknotensbar = new Scrollbar(Scrollbar.HORIZONTAL,1,1,1,30));
           
      Scrollings[2] = hilf;
      startknotensbar.setPageIncrement(2);
      startknotensbar.setLineIncrement(1);
      startknotensbar.setValue(startrate);

      Scrollings[3] = new Panel();
      Scrollings[3].setLayout(new GridLayout(3,1));
    
      infos[0] = new Label("");
    
      infos[1] = new Label("This affects the actual node.",Label.CENTER);

      infos[2] = new Label("");

      for ( int i = 0; i < 3; i++)
         Scrollings[3].add(infos[i]); 
      
     for ( int i = 4; i < (queuezahl+3); i++ )
      {
        hilf = new Panel();
        hilf.setLayout(new GridLayout(2,1));
        hilf.add(queuelabel[i-4] = new Label("Queue "+(i-4)+" node "+akt_knoten.gib_queue(i-4).gib_zielknoten().gib_id()+" exit after "+queueraten[i-4]+" passes",Label.CENTER));
        hilf.add(sbar[i-4] = new Scrollbar(Scrollbar.HORIZONTAL,1,1,1,30));
        Scrollings[i] = hilf;
        sbar[i-4].setPageIncrement(2);
        sbar[i-4].setLineIncrement(1);
        sbar[i-4].setValue(queueraten[i-4]);
      } // for  

      Schalter.setLayout(new FlowLayout());
      Schalter.add(ok = new Button("Ok"));
      Schalter.add(cancel = new Button ("Cancel"));
   
      for ( int i = 0; i < (queuezahl+3); i++)
          add(Scrollings[i]);

      add("South",Schalter);
   } // Austoss.Austoss

   public boolean handleEvent(Event evt) {
      if (evt.id == Event.WINDOW_DESTROY&& evt.target == this) {
         this.hide();
         this.dispose();
      }
      else if (   evt.id ==Event.SCROLL_ABSOLUTE
               || evt.id ==Event.SCROLL_LINE_DOWN
               || evt.id ==Event.SCROLL_LINE_UP
               || evt.id ==Event.SCROLL_PAGE_DOWN
               || evt.id ==Event.SCROLL_PAGE_UP)
        {
            startknotenqueue.setText("Queue-rate start-node : "+startknotensbar.getValue()+"     ");
            for ( int i = 0; i < (queuezahl-1) ; i++)
              {
                 queueraten[i] = sbar[i].getValue(); 
                 queuelabel[i].setText("Queue "+i+" node "+akt_knoten.gib_queue(i).gib_zielknoten().gib_id()+" exit after "+queueraten[i]+" passes");
	      } // for
          return true;
      }
      else if(evt.target == ok) {
         puCl.NetzwerkCanvas.reset_flussfeld();
         puCl.NetzwerkCanvas.ausstoss= startknotensbar.getValue();
         for ( int i = 0; i < queuezahl-1 ; i++)
            puCl.NetzwerkCanvas.setze_queueraten(i,sbar[i].getValue()); 
         puCl.queuerate_reset();
         this.hide();
         this.dispose();
         return true;
      } 
      else if(evt.target == cancel) {
         this.hide();
         this.dispose();
         return true;
      } // if     
      return super.handleEvent(evt);
   } // Ausstoss.handleEvent
} // Ausstoss


