/* 
 * @(#) Netzwerkdarstellung.java
 */

/**
 * @author Didier Gutacker
 * @version 1.0, 12.08.97 
 * @see Netzknoten
 * @see HotPotato
 * @see Oberflaeche
 */

import java.awt.*;
import java.applet.*;
import java.net.*;

class Netzwerkdarstellung extends Canvas implements Runnable
{

   /* Netzknotenvariablen */
  
   private static final int maxknoten = 15;
   private Netzknoten[] Netzwerk;
   private int netzknotenzahl = 0;
   private int aktuelle_id;
  
   private boolean beruehrt; /* Rechner beruehrt ? */
   private boolean sflag = false; /* Startknoten-Button gedrueckt ? */
   private boolean zflag = false; /* Zielknoten-Button gedrueckt ? */
   private boolean effels = false; /* Effelsberg-Demonetzwerk == aktuelles Netzwerk ? */
  
   /* Variablen zur Darstellung */

   private static final int breite = 50; /* Breite der Netzknoten */
   private static final int hoehe = 50; /* Hoehe der Netzknoten */
   private int maxComponentWidth = breite + 10;  /* maximale Komponentenbreite, wird fuer Netzwerk-Layout benoetigt */
   private int maxComponentHeight = hoehe + 10; /* maximale Komponentenhoehe, wird fuer  Netzwerk-Layout benoetigt */
   private static final int qb = 30; /* Breite der Queues */
   private static final int qh = 30; /* Hoehe der Queues */
   private Point lo; /* Linke obere Ecke der Zeichenflaeche */
   private Point ru; /* Rechte untere Ecke der Zeichenflaeche */
   private int startknoten; /* Knotenid des Startknotens  */
   private int zielknoten; /*  Knotenid des Zielknotens */
   private Dimension d; /* Ausmasse der Zeichenflaeche */
   private Image[] imagefeld; /* Bildfeld fuer die Abbildungen der Pfeile */
   MediaTracker  tracker; /* Ueberwacht den LAdevorgang der Bilder */

   /** Variablen fuer die Animation */

   private boolean animation_laeuft = false; /* Zustandsvariable fuer die Animation des aktuellen Netzknotens */
   private boolean anim_oben_laeuft = false; /* Zustandsvariable fuer die Animation der Netzwerkuebersicht */
   private boolean repaint_laeuft = false; /* Zustandsvariable fuer das Neuzeichnen - Wichtig um die Animation fehlerfrei ablaufen zu lassen */
   private boolean animation_ende = false;  /* Zustandsvariable um die Animation vor dem natuerlichen Ende abzubrechen */
   private Point anim_oben; /* Koordinaten des Datenpakets waehrend der Animation des aktuellen Netzknotens - zur Fehlervermeidung */
   private Point anim_punkt; /* Koordinaten des Datenpakets waehrend der Animation der Netzwerkuebersicht - zur Fehlervermeidung */
   private int anim_dicke = 10; /* Groesse des Datenpakets fuer die Animation */
   public int anim_delay = 300; /* Wartezeit waehrend der Animation */
   private static int anzahl_aus=0; /* Anzahl der Datenpakete, die das Ziel erreicht haben ! */
   private static int anzahl_ein=0; /* Anzahl der Datenpakete, die im Startknoten erzeugt wurden */ 
   int ausstoss=5; /* Anzahl der Datenpakete die in einem Schleifendurchlauf erzeugt werden */
   private int[] flussfeld; /* Feld fuer die Ausstossraten der Queues des aktuellen Knotens */
   private int flussfeldgroesse = 0; /* Zahl der Queues im aktuellen Knoten, gibt die Groesse des Flussfeldes vor */
   private int[] anim_flussfeld;   /* Feld zum Zaehlen der Durchlaeufe bei jeder Queue des aktuellen Knotens */

   /* Threadvariablen */

   Thread netzwerkthread;
   private ThreadGroup threadgroup;

   /* Variable die eine Referenz auf das Applet fuer die Klasse Netzwerkdarstellung bereitstellt */

  private HotPotato mainapplet; 

   /* Variable zur Uebergabe der Referenz auf die Oberflaeche zur
      Bearbeitung der Mouseevents Mousemove, Mousedown */
 
   private Oberflaeche fenster;

   /** Konstruktor */

  public Netzwerkdarstellung(Oberflaeche fen, HotPotato m)
   {

     fenster = fen;    
     mainapplet = m; 
     threadgroup = mainapplet.threadgroup;
     setBackground(Color.white);
   
     lo = new Point(0,0);
     ru = new Point(0,0);  
     anim_punkt = new Point(0,0);
     anim_oben = new Point(0,0);

     Netzwerk = new Netzknoten[maxknoten];

     /** Netzwerk aufbauen */

    demonetz(); 

    /** aktuellen Knoten festlegen */

    aktuelle_id = startknoten;

    /**  Bilder fuer die Darstellung des Netzknotens laden */
   
    tracker  =  new  MediaTracker(this);
    imagefeld = new Image[3];
    imagefeld[0] = mainapplet.getImage(mainapplet.getCodeBase(), "pfeil_oben.gif");
    tracker.addImage(imagefeld[0],  0);
    imagefeld[1] = mainapplet.getImage(mainapplet.getCodeBase(), "pfeil_unten.gif");
    tracker.addImage(imagefeld[1],  0);     
    imagefeld[2] = mainapplet.getImage(mainapplet.getCodeBase(), "pfeil_rechts.gif");
    tracker.addImage(imagefeld[2],  0);
    try  {
           tracker.waitForID(0);
          }
     catch  (InterruptedException  e)  {  } 
   if ( tracker.isErrorAny() )
        { 
          fenster.Erklaerungen.appendText("Error while loading the images!");
	} // if
   /** Erzeugen und setzen der Felder fuer die Ausstosskontrolle */
   flussfeld = new int[maxknoten];
   anim_flussfeld = new int[maxknoten];
   reset_flussfeld();
   } // Netzwerkdarstellung.Netzwerkdarstellung

   /** gibt die Zahl der Datenpakete die pro Durchlauf der ``forever´´-Schleife  der ``run´´-Methode im Startknoten
       erzeugt werden */

  public int gib_ausstoss()
  {
    return(ausstoss);
  } // Netzwerkdarstellung.gib_ausstoss

/** Demonstrationsnetzwerk von Prof. Effelsberg */

  public void effelsberg_demonetz()
  {
     effels = true;
     addknoten("aim");
     zielknoten = 0;
     addknoten("node");
     addknoten("start");
     startknoten = 2;
     addknoten("node");
     addknoten("node");
     setqueue(0,1);
     setqueue(0,4);
     setqueue(1,2);
     setqueue(1,4);
     setqueue(2,3);
     setqueue(3,4);  
  } // Netzwerkdarstellung.effelsber_demonetz

/** Standard-Demonstrationsnetzwerk */

  public void demonetz()
  {
     effels = false;
     addknoten("node");
     addknoten("start");
     addknoten("node");
     startknoten = 1;
     addknoten("node");
     addknoten("aim");
     zielknoten = 4;
     addknoten("node");
     setqueue(0,1);
     setqueue(0,2);
     setqueue(1,2);
     setqueue(1,3);
     setqueue(1,4);
     setqueue(3,4);
     setqueue(0,3);
     setqueue(2,3);
     setqueue(3,5);
     setqueue(2,5);
     setqueue(0,5);
     setqueue(4,5);
  } // Netzwerkdarstellung.demonetz

/** Das Array, das das Netzwerk, d.h. die Netzknoten aufnimmt, wird zurueckgesetzt */

  public void loesche_netzwerk()
  {
    for ( int i = 0; i < netzknotenzahl; i++)
    {
      Netzwerk[i]=null;
    } // for
    netzknotenzahl = 0;
  } // Netzwerkdarstellung.loesche_netzwerk
  
 /** Das Demonstrationsnetzwerk von Prof. Effelsberg wird zum aktuellen Netzwerk gemacht */

  public void setze_effels()
  {
    if ( animation_laeuft )
    {
      animation_ende = true;
    }
    loesche_netzwerk();
    effelsberg_demonetz();
    reset();
    repaint();
  }  // Netzwerkdarstellung.setze_effels

 /** Das Standard-Demonstrationsnetzwerk wird zum aktuellen Netzwerk gemacht */

  public void setze_standard()
  {
    if ( animation_laeuft )
    {
      animation_ende = true;
    }
    loesche_netzwerk();
    demonetz();
    reset();
    repaint();
  }  // Netzwerkdarstellung.setze_standard

 /** Zuruecksetzen der Flussfelder */

  public void reset_flussfeld()
  {
      flussfeldgroesse =Netzwerk[startknoten].gib_queue_anzahl();
      for( int i = 0; i < flussfeldgroesse; i++ )  
      {
        anim_flussfeld[i] = 0;
        flussfeld[i]=1 ;
       } // for
  }  // Netzwerkdarstellung.reset_flussfeld

 /** Gibt die ID des aktuellen Netzknotens zurueck */

  public int gib_aktuelle_id()
  {
    return(aktuelle_id);
  }  // Netzwerkdarstellung.gib_aktuelle_id

 /** Startknoten-Button wurde gedrueckt */

  public void setze_sflag()
  {
     sflag = true;
  }  // Netzwerkdarstellung.setze_sflag

  /** Zielknoten-Button wurde gedrueckt */
 
   public void setze_zflag()
   {
      zflag = true;
   }  // Netzwerkdarstellung.setze_zflag

  /** Gibt die Anzahl an Knoten im dargestellten Netzwerk zurueck */

  public int gib_netzknotenzahl()
  {
     return(netzknotenzahl); 
  }  // Netzwerkdarstellung.gib_netzknotenzahl

  /** Gibt aktuellen Netzknoten zurueck */

  public Netzknoten gib_akt_knoten()
  {
     return(Netzwerk[aktuelle_id]);
  }  // Netzwerkdarstellung.gib_akt_knoten

  /** Gibt den Zustand der Animation zureuck */

  public boolean gib_anim_laeuft()
  {
     return(animation_laeuft);
  }  // Netzwerkdarstellung.gib_anim_laeuft

  /** Gibt die Ausstossraten der Queues des aktuellen Netzknotens zurueck */

  public int gib_queueraten( int temp )
  {
    return(flussfeld[temp]);
  }  // Netzwerkdarstellung.gib_queueraten

  /** Setzt die Ausstossrate der Queue zahl des aktuellen Netzknotens auf den Wert wert*/

  public void setze_queueraten(int zahl, int wert)
  {
     flussfeld[zahl]=wert;
  }  // Netzwerkdarstellung.setze_queueraten

  /** Zuruecksetzten der der Animation zugrundeliegenden Datenstrukturen */

  public void reset()
  {
     Warteschlange hilf;
     Datenpaket temp;

     /**
      *  setzt die Anzahl der Datenpaket zurueck
      */
 
     /**
      *  @see Datenpaket 
      */

     Datenpaket.setze_anzahl_zurueck();

     /** alle Queues leeren und setze den Zustand der Knoten zurueck */

     for ( int i = 0; i < netzknotenzahl; i++)
     { 
       Netzwerk[i].setze_zustand("node");
       for ( int j = 0; j < Netzwerk[i].gib_queue_anzahl() ; j++)
       {
          hilf = Netzwerk[i].gib_queue(j);
          while ( hilf.groesse() > 0)
	    {  temp = hilf.holen();   } // while     
       } // for

       /** Start- und Zielknoten festlegen */

      if ( effels )
      {
        startknoten = 0;
        zielknoten = 2;
      }
      else
      {
        startknoten = 1;   
        zielknoten = 4;
      } // if

     } // for
   
     Netzwerk[startknoten].setze_zustand("start");
     Netzwerk[zielknoten].setze_zustand("aim");
   
     reset_flussfeld();
     repaint();
   
     /** Variablen zuruecksetzen */

     anzahl_ein = 0;
     anzahl_aus = 0;
     aktuelle_id = startknoten;

  } // Netzwerkdarstellung.reset


  /** neuen Knoten einfuegen */
 
   public void addknoten(String art)
   {
     if ( netzknotenzahl < maxknoten )
       {  
         Netzknoten temp;
         temp = new Netzknoten();
         temp.setze_zustand(art);
         temp.setze_id(netzknotenzahl);
         Netzwerk[netzknotenzahl] = temp;
         netzknotenzahl++;   
       } // if
   } // Netzwerkdarstellung.addknoten

   /** Knotenverbindungen setzten */

   public void setqueue(int von, int zu)
   {
     if ( Netzwerk[von] != null && Netzwerk[zu] != null )
       {
         Netzwerk[von].verbinde_knoten(Netzwerk[zu]);
         Netzwerk[zu].verbinde_knoten(Netzwerk[von]);
       } // if
     }  // Netzwerkdarstellung.setqueue

   /** Pruefen, ob Mauszeiger ueber einem Netzknoten */

   public int find(int x ,int y )
    {   
      for ( int z = 0; z < netzknotenzahl; z++)
        { 
          if ( Netzwerk[z] !=null 
            && Netzwerk[z].gib_x() <= x && x <= (Netzwerk[z].gib_x() + breite )
            && Netzwerk[z].gib_y() <= y && y <= (Netzwerk[z].gib_y() + hoehe )  )
            { 
              return z;
	    } // if
	} // for
        return -1;
    } // Netzwerkdarstellung.find

   /** Mousebewegungen im NetzwerkCanvas abfangen */

   public boolean mouseMove(Event evt, int x, int y)
   {
      int gefunden = -1;
      gefunden = find(x,y);    
      if ( gefunden != -1 )
        {
          if (beruehrt != true);
            {
               fenster.setCursor(Frame.CROSSHAIR_CURSOR);
               beruehrt = true;
	    } // if
        }
       else
	 {
         if ( beruehrt != false )
            {
               fenster.setCursor(Frame.DEFAULT_CURSOR); 
               beruehrt = false;
	    } // if
	 } // if
      return true;
      } // Netzwerkdarstellung.mouseMove

   /** Pruefung auf klick auf Netzknoten */

   public boolean mouseDown(Event evt, int x, int y)
   {
      if (evt.clickCount == 1)
        {
          int gefunden = -1;
          gefunden = find(x,y);

          /** gefunden enthaelt den Netzknoten auf den geklickt wurde, sonst -1 */

          if ( gefunden != -1 )
            {

             /** Startknoten-Button gedrueckt , Mouseklick nicht auf Start- oder Zielknoten */

              if ( sflag && ( gefunden != zielknoten ) && ( gefunden != startknoten ))
                { 
                    Netzwerk[gefunden].setze_zustand("start");
                    Netzwerk[startknoten].setze_zustand("node");
                    startknoten = gefunden;
                    fenster.zknoten.enable();
                    sflag = false;

                    repaint();

                   /** Falls Animation laeuft, Animation unterbrechen */
                   if ( animation_laeuft )
                       {
                        animation_ende = true;
		       } //if
                  } 
              else

                 /** Zielknoten-Button gedrueckt, Mouseklick nicht auf Start- oder Zielknoten */

                 if ( zflag && ( gefunden != startknoten ) && ( gefunden != zielknoten ))
                   {
                      Netzwerk[gefunden].setze_zustand("aim");
                      Netzwerk[zielknoten].setze_zustand("node");
                      zielknoten = gefunden;
                      fenster.sknoten.enable();
                      zflag = false;

                      repaint();

                      /** Falls Animation laeuft, Animation unterbrechen */

                      if ( animation_laeuft )
                         {
                           animation_ende = true;
                         } // if
                    }
                else
                  {  if ( gefunden != aktuelle_id )
		     {
	               /** Falls Animation laeuft, Animation unterbrechen */

                       if ( animation_laeuft )
                       {
                         animation_ende = true;
                         } // if	    
                       /** neuer aktueller Netzknoten */

                       aktuelle_id = gefunden;
                       reset_flussfeld();
                     
                       repaint();
 
                     } // if
                  } // if
            } // if
        } // if
      return true;
    } // Netzwerkdarstellung.mouseDown

  /** Verbindungslinien in der Netzwerkuebersicht zeichnen */

  public void zeichne_verbindungen(Graphics g)
  {
    int hilfx = ( breite/2 );
    int hilfy = ( hoehe/2 );
    for ( int i = 0 ; i < netzknotenzahl ; i++)
        { 
          int hilf;
          Netzknoten temp;
          hilf = Netzwerk[i].gib_queue_anzahl();
          for ( int j = 0; j < hilf; j++)
            { 
              temp = Netzwerk[i].gib_queue_ziel(j);
              g.setColor(Color.red);
              g.drawLine((Netzwerk[i].gib_x()+hilfx),(Netzwerk[i].gib_y()+hilfy),(temp.gib_x()+hilfx),(temp.gib_y()+hilfy));
	    } // for
	} // for
      mainapplet.getToolkit().sync();
  } // Netzwerkdarstellung.zeichne_verbindungen

  /** Netzknoten aktualisieren */

  public void aktualisiere_netzknoten()
  {
    Graphics g;
    g = this.getGraphics();   
    repaint_laeuft = true;
    zeichne_knoten(g,true);
    repaint_laeuft = false;
  } // Netzwerkdarstellung.aktualisiere_netzknoten

  /** vertikale Linie zeichnen */

 public  void zeichne_vertikale_linie(int x_von, int x_bis, int y_von ,int dicke, Graphics g )
  {
    int x = x_von;
    int y = y_von;
    int ende = x_bis;
    int d = dicke;
    while( x <= ende )
      {
        g.setColor(Color.red);
        g.drawRect(x,y,d,d);
        g.fillRect(x,y,d,d);
        x +=(int)d/2;
      } // while
     mainapplet.getToolkit().sync();
  } // Netzwerkdarstellung.zeichne_vertikale_linie

  /** horizontale Linie zeichnen */

  public  void zeichne_horizontale_linie(int x_von, int y_von, int y_bis ,int dicke, Graphics g )
  {
    int x = x_von;
    int y = y_von;
    int ende = y_bis;
    int d = dicke;
    while( y <= ende )
      {
        g.setColor(Color.red);
        g.drawRect(x,y,d,d);
        g.fillRect(x,y,d,d);
        y +=(int)d/2;
      } // while  
     mainapplet.getToolkit().sync();
  } // Netzwerkdarstellung.zeichne_horizontale_linie

  /** Netzknoten zeichnen */

  public  void zeichne_netzknoten(Graphics g)
  {
     for ( int i = 0 ; i < netzknotenzahl; i++)
        { 
           if ( Netzwerk[i] != null )
           { 
             String temp = Netzwerk[i].gib_zustand();
             zeichne_rechner(Netzwerk[i],g);
             if ( i == aktuelle_id )
             zeichne_rahmen((Netzwerk[i].gib_x()-10),(Netzwerk[i].gib_y()-10),(breite+15),(hoehe+15),5,g);
	   } // if
	}  // for
      mainapplet.getToolkit().sync(); 
  } // Netzwerkdarstellung.zeichne_netzknoten

  /** Rahmen zeichnen */

  public  void  zeichne_rahmen(int x, int y, int width, int height, int dicke, Graphics g)
  {
    g.setColor(Color.red);
    zeichne_horizontale_linie(x,y,(y+height),dicke,g);
    zeichne_vertikale_linie(x,(x+width),(y+height),dicke,g);
    zeichne_horizontale_linie((x+width),y,(y+height), dicke,g);
    zeichne_vertikale_linie(x,(x+width),y,dicke,g);
  } // Netzwerkdarstellung.zeichne_rahmen

  /** Rechner zeichnen */

  public  void  zeichne_rechner(Netzknoten aktuell, Graphics g)
  {
    /* Variablen */

    int x;
    int y;
    Font f;
    FontMetrics fm;
    String s1;
    String s2;  

    /* Variablen initialisieren */

    x = aktuell.gib_x();
    y = aktuell.gib_y();
    f = new Font("Helvetica",Font.BOLD,10);
    s1 = "Station " + aktuell.gib_id();
    s2 = aktuell.gib_zustand();

    /* eigentlichen Rechner zeichnen */

    g.setColor(Color.blue);
    g.drawRect(x,y,breite,hoehe);
    g.fillRect(x,y,breite,hoehe);
   
    /* Rechner beschriften */  

    g.setColor(Color.yellow);
    g.setFont(f);
    fm = g.getFontMetrics(f);
    x += 3;
    y += 15;
    g.drawString(s1,x,y);
    y += fm.getHeight();
    g.drawString(s2,x,y); 
    mainapplet.getToolkit().sync();
  } // Netzwerkdarstellung.zeichne_rechner

  /** Netzwerkuebersicht zeichnen */

   public void paint(Graphics g)
   { 
    
     repaint_laeuft = true;

     berechnungen();

     /** Netzwerkverbindungen zeichnen */   
   
     zeichne_verbindungen(g);
                
     /** Netzknoten zeichnen */
   
     zeichne_netzknoten(g);

     /** Trennungslinie zeichnen */

     zeichne_vertikale_linie(0,(d.width),((d.height/2)-2),4,g);

     /** aktuellen Netzknoten zeichnen */

     zeichne_knoten(g,false);
  
     /** Falls Animation laeuft, stehengebliebenes Datenpaket loeschen */

     if ( animation_laeuft )
      {
        g.setColor(Color.red);
        g.setXORMode(this.getBackground());
        g.fillRect(anim_punkt.x,anim_punkt.y,anim_dicke,anim_dicke);  
        mainapplet.getToolkit().sync();
      } // if
     
     /** Falls Animation in der Netzwerkuebersicht laeuft, stehengebliebenes Datenpaket loeschen */

     if ( anim_oben_laeuft )
      {
        g.setColor(Color.red);
        g.setXORMode(this.getBackground());
        g.fillOval(anim_oben.x,anim_oben.y,anim_dicke,anim_dicke);  
        mainapplet.getToolkit().sync();
      } // if  

    repaint_laeuft = false;

   } // Netzwerkdarstellung.paint

  /** Zeichnen des aktuellen Netzknotens */

  public void zeichne_knoten( Graphics g, boolean aktualisieren)
  { 
    Font f;
    f = new Font("Helvetica",Font.BOLD,10);
    g.setFont(f);
    /** Koordinaten des Netzknotenteils im Canvas */

    lo.x =  0;
    lo.y = (d.height/2);
    ru.x = d.width;
    ru.y = d.height;
    int  x_center = ( lo.x+ru.x ) / 2;
    int y_center = ( lo.y+ru.y) / 2;
    
    /** Zeichne Netzknoten */

    int x_knoten = (x_center-(ru.x/4));
    int y_knoten = (y_center-(ru.y/8));
    int x_breite  = (ru.x/2);
    int y_hoehe  = (ru.y/4);
    int xpf = 0;
    int ypf = 0;

    xpf = x_center-((6*x_center)/8)-((4*qb)/3);
    ypf = y_center-((2*qh)/3);

    /** Falls zum ersten mal gezeichnet, Grafik Pfeil_nach_rechts.gif links vom aktuellen Knoten einbinden */

    if ( !aktualisieren )
     {
       /** Pfeil IN zeichnen */
 
       g.drawImage(imagefeld[2],xpf,ypf,this);

       xpf = x_center+(x_breite/2);
     } // if

    /** Falls aktueller Netzknoten der Startknoten ist, ``Eingangsqueue´´  einzeichnen */

    if ( aktuelle_id == startknoten )
     {
       g.setColor(Color.green);    
       g.fillRect((lo.x+2),(y_center-(qh/2)),qb,qh);
       g.setColor(Color.red);
       g.drawString(""+anzahl_ein,(lo.x+5),(y_center+2));
       if ( !aktualisieren )
        {
          g.setColor(Color.black);
          g.drawString("created data-packages",(lo.x+5),(y_center-(qh)));
	} // if
     } // if

    /** Falls aktueller Netzknoten der Zielknoten ist, ``Ausgangspfeil´´ und ``Zielqueue´´ einzeichnen */

    if ( aktuelle_id == zielknoten )
      {
 
        /* Queue OUT und Pfeil OUT zeichnen */ 

         g.drawImage(imagefeld[2],xpf,ypf,this);
         g.setColor(Color.green);    
         g.fillRect((ru.x-qb-5),(y_center-(qh/2)),qb,qh);
         g.setColor(Color.red);
         g.drawString(""+anzahl_aus,(ru.x-qb+3),(y_center+2));

         /** Falls zum ersten mal gezeichnet, Grafik Pfeil_nach_rechts.gif rechts vom aktuellen Knoten einbinden */

         if ( !aktualisieren )
          {    
            g.setColor(Color.black);
            g.drawString("reached the aim",(ru.x-(2*qb)-5),(y_center-(qh)));
	  } // if
      } // if

      /** Queues zeichnen */
  
     if ( aktuelle_id != -5)
       {
         int anzahl=0;
         int teiler;
      
         /** Positionierung der Queues im aktuellen Netzknoten berechnen */

         switch( (Netzwerk[aktuelle_id].gib_queue_anzahl()) )
         {
           case 0: case 1: case 2: teiler = 1; break;
           case 3: case 4:  teiler = 2; break;
           case 5: case 6: teiler = 3; break;
           default :
             teiler = 0; break;
	 } // switch
    
        /** Queues einzeichnen */

        for (int i = 0 ; i < teiler; i++)
        {
          int x_pos;

          /** x_pos berechnenn */

          if ( teiler > 1 )
          {
            x_pos = x_knoten+(i/(teiler-1))*x_breite;
            if ( i != (teiler-1) )
             x_pos = x_pos+qb;
          }
         else
	   {
             x_pos = x_knoten+qb;
           } // if
          int y_pos = y_knoten;
          g.setColor(Color.blue);

          /** Pfeil_nach_oben.gif einbinden */

          g.drawImage(imagefeld[0],(x_pos-((4*qb)/3)+3),lo.y+5,this);

          /** Queuepositionen in Queues speichern */

          Netzwerk[aktuelle_id].gib_queue(anzahl).setze_xpos(x_pos-qb);
          Netzwerk[aktuelle_id].gib_queue(anzahl).setze_ypos(y_pos);

          /** Queue zeichnen */

          g.fillRect((x_pos-qb),y_pos,qb,qh);

          /** Falls zum ersten mal, Pfeil beschriften */

          if (! aktualisieren )
	    g.drawString("zu Knoten "+Netzwerk[aktuelle_id].gib_queue(anzahl).gib_zielknoten().gib_id(),(x_pos-((10*qb)/3)),lo.y+qh); // if
        g.setColor(Color.red);

          /** Zahl der Datenpakete der Queue in die Queue eintragen */

          g.drawString(""+Netzwerk[aktuelle_id].gib_queue(anzahl).groesse(),(x_pos-qb)+5,y_pos+18);
          anzahl++;
          g.setColor(Color.blue);

          /** Falls unten auch eine Queue hin soll */   

          if ( anzahl <= (Netzwerk[aktuelle_id].gib_queue_anzahl()-1) )
           {
             y_pos = y_knoten-qh+(y_hoehe);
         
             /** Pfeil_nach_unten.gif  einbinden */

             g.drawImage(imagefeld[1],(x_pos-((4*qb)/3)+3),y_pos+(qh/2),this);

             /** Queueposition in Queue speichern */

             Netzwerk[aktuelle_id].gib_queue(anzahl).setze_xpos(x_pos-qb);
             Netzwerk[aktuelle_id].gib_queue(anzahl).setze_ypos(y_pos);

             /** Queue zeichnen */

             g.fillRect((x_pos-qb),y_pos,qb,qh);

             /** Falls zum ersten mal, Pfeil beschriften */

             if ( !aktualisieren )
               g.drawString("node "+Netzwerk[aktuelle_id].gib_queue(anzahl).gib_zielknoten().gib_id(),(x_pos-((10*qb)/3)),y_pos+((5*qh)/3)); // if
            g.setColor(Color.red);

            /** Zahl der Datenpakete der Queue in die Queue eintragen */
            g.setFont(f);
            g.drawString(""+Netzwerk[aktuelle_id].gib_queue(anzahl).groesse(),(x_pos-qb)+5,y_pos+18);
            anzahl++;
	   } // if
        } // for

      /** Knoten plus Inhalt zeichnen */
  
      g.setColor(Color.blue);
      g.drawRect(x_knoten,y_knoten,x_breite,y_hoehe);
      g.drawOval((x_center-(ru.x/18)),(y_center-(ru.y/19)),(ru.x/10),(ru.y/10));

      /** Zeichenfarbe auf rot zuruecksetzen */

      g.setColor(Color.red);
      } // if 
     mainapplet.getToolkit().sync();
  }// Netzwerkdarstellung.zeichne_knoten

  /** Thread starten */

  public void start()
   {
     if ( netzwerkthread == null )
      {
        netzwerkthread = new Thread(threadgroup, this);
        netzwerkthread.setPriority(1);
        netzwerkthread.start();
      } // if
   } // Netzwerkdarstellung.start

   /** Thread stoppen */

   public void stop()
   {
     if (( netzwerkthread != null) && netzwerkthread.isAlive() )
       {
         netzwerkthread.stop();
         netzwerkthread = null;
       } // if
   } // Netzwerkdarstellung.stop
 
     
  /** Berechnen der Positionen der Netzknoten in der Netzwerkuebersicht */

  public void berechnungen()
   {
     d = size();
     
      /** Koodinaten fuer die Rechnerpositionierung berechnen */

     int containerWidth = d.width;
     int containerHeight = d.height/2; 
     int xradius = (containerWidth - maxComponentWidth ) / 2;
     int yradius = (containerHeight - maxComponentHeight ) / 2;
     int xcenter = containerWidth / 2;
     int ycenter = containerHeight / 2;
      
     for (int i = 0; i < netzknotenzahl; i++)
     {
       if ( Netzwerk[i] != null ) 
         {  
           double angle = 2 * Math.PI * i / netzknotenzahl;
           int x = xcenter + (int)(Math.cos(angle) * xradius);
           int y = ycenter + (int)(Math.sin(angle) * yradius); 
           Netzwerk[i].setze_koordinaten((x-2*(breite/3)),(y-(hoehe/2)));
	 } // if
     } // for

  }// Netzwerkdarstellung.berechnungen

 /** Hier ist der eigentliche HotPotato-Algorithmus implementiert :
        Es wird die Queue mit den wenigsten Datenpaketen gesucht und zurueckgegeben.
        Wichtig : Einzige Bedingung ist das das Datenpaket nicht direkt wiede zurueck-
                         geschickt wird */

 public int routing(int t, Datenpaket hilf)
 {
   int kleinste;

   /** ``Anfangs´´-``kleineste Queue´´ waehlen */
   /** Falls das Datenpaket vom Netzknoten zu dem die Queue 0 des Netzknotens in den das Datenpaket
         geleitet wurde, kam diese Queue ueberspringen */

   if ( hilf.gib_startknoten() != Netzwerk[t].gib_queue(0).gib_zielknoten().gib_id() )
      kleinste = 0; 
   else
     kleinste = 1; // if

 /** alle Queues des Netzknotens durchgehen und kleinste merken */

  for ( int i = 0; i < Netzwerk[t].gib_queue_anzahl(); i++)
  {
     /** Falls Queue i kleiner gleich Queue kleinste, dann ``markiere´´ Queue  i
            als kleinste Queue */

      if (  Netzwerk[t].gib_queue(i).groesse() <= Netzwerk[t].gib_queue(kleinste).groesse() )
        if ( hilf.gib_startknoten() !=  Netzwerk[t].gib_queue(i).gib_zielknoten().gib_id()  )
          kleinste = i; // if // if
  } // for
   return(kleinste);
 } // Netzwerkdarstellung.routing

/** Run-Methode des Threads. Hier werden alle Aktivitaeten koordiniert. */

 public void run()
   {
      Netzknoten akt_knoten;
      Datenpaket hilf;
      int ziel = 0;
      Warteschlange akt_queue; 

      /** Endlos-Schleife : dauerhaftes Routing im Netzwerk */

      for ( ;; )
      { 

        /** Durchgehen aller Netzknoten des Netzwerks */

        for ( int i = 0; i < netzknotenzahl; i++)
          {

            /** Falls Startknoten gleich betrachteter Knoten, neue Datenpakete im Startknoten erzeugen */

            if ( Netzwerk[i].gib_id() == startknoten )
              {
                /** erzeuge k Datenpakete pro Durchlauf der Netzknotenschleife */

                for ( int k = 0; k < ausstoss; k++)
	        {
                   hilf = new Datenpaket(startknoten,zielknoten);
                   ziel = routing(i,hilf);

                  /* Manipulation aus Animationsgruenden, um die Anzahl der erzeugten Datenpakete richtig darzustellen */

                  if ( anzahl_ein == 0 )
                    anzahl_ein++; // if 
             
                 /** Animation des Eingangs eines Datenpakets, falls der aktuelle Netzknoten der gerade betrachtete ist */

                  if ( i == aktuelle_id ) 
                   {
                     fenster.Erklaerungen.appendText("data-package "+hilf.gib_id()+" created and routed in the start-node of the queue to the node "+Netzwerk[i].gib_queue(ziel).gib_zielknoten().gib_id()+"\n");
                     anim_eingang(startknoten,ziel);
		   } // if

                  /** Datenpaket in Queue ziel einfuegen und Darstellung aktualisieren falls aktueller Netzknoten gleich
                         gerade betrachtetem */

                  Netzwerk[i].gib_queue(ziel).einfuegen(hilf);
                  if ( i == aktuelle_id )
		    aktualisiere_netzknoten(); // if

                  /** Anzahl erzeugter Datenpakete hochzaehlen */

                  anzahl_ein++;
		} // for
              } // for
           
           /* Jede Queue im betrachteten Knoten besuchen */
             
             for ( int j = 0; j < Netzwerk[i].gib_queue_anzahl(); j++)
	     {
                  /** Sind Datenpakete in der Queue j des Netzknotens ? */

                  if ( Netzwerk[i].gib_queue(j).groesse() > 0 )
                    {

                       /** Zahl der nicht bearbeiteten Durchlaeufe der Queue j im aktuellen Knoten hochzaehlen */

                      if ( aktuelle_id == i  )
                        anim_flussfeld[j]++; // if

                      /**   aktueller Netzknoten nicht gleich gerade betrachtetem Netzknoten
                          oder 
                                 aktueller Netzknoten gleich gerade betrachtetem Netzknoten
                              und
                                 die Queue j hat flussfeld[j] Druchlaeufe pausiert */
 
                      if ( aktuelle_id !=i || ( ( aktuelle_id == i ) && ( anim_flussfeld[j] == flussfeld[j]) ))
                      {
                        /** Datenpaket aus Queue j holen */
 
                        hilf = Netzwerk[i].gib_queue(j).holen();

                        /** Falls if wegen der 2. Bedingung erfuellt war, anim_flussfeld zuruecksetzen */

                        if ( ( aktuelle_id == i ) && ( anim_flussfeld[j] == flussfeld[j] ) )
                        {
                           anim_flussfeld[j] = 0; 
                        } // if

                       if ( aktuelle_id == i )
			 aktualisiere_netzknoten(); // if
                 
                       /** Erreicht das Datenpaket den Zielknoten ? */

                       if ( Netzwerk[i].gib_queue(j).gib_zielknoten().gib_id() == zielknoten )
                       {
                          /** Anzahl der Datenpakete, die das Ziel erreicht haben, hochzaehlen */

                          anzahl_aus++;
                      
                          /** Ist der Zielknoten der aktuelle Knoten ? */

                          if ( aktuelle_id == zielknoten )
                          {

                             /** Animation Datenpaket erreicht Ziel */
                      
                             fenster.Erklaerungen.appendText("data-package  "+hilf.gib_id()+" reached the aim!\n");
                             anim_ausgang(zielknoten,-1); 
			  } // if

                         /** Falls aktueller Netzknoten gleich gerade betrachtetem Netzknoten */

                         if ( aktuelle_id == i )  
	                  {
                           /** Animation Eingang bei Netzknoten Netzwerk[i] */
                            
                            fenster.Erklaerungen.appendText("data-package "+hilf.gib_id()+" is routed to the node "+Netzwerk[i].gib_queue(j).gib_zielknoten().gib_id()+"\n");
                            anim_ausgang(i,j);
			  } // if
	               }
                       else /** Datenpaket erreicht einen beliebigen Netzknoten ( nicht den  Zielknoten ! ) */
	               {
                          /** neues Ziel bestimmen */

                          ziel = routing(Netzwerk[i].gib_queue(j).gib_zielknoten().gib_id(),hilf);

                         /** Dem Datenpaket mitteilen in welchem Netzknoten es augenblicklich ist.
                                Dies wird fuer die Routingbedingung benoetigt ! */

                          hilf.setze_startknoten(i);

                          /** Falls aktueller Netzknoten gleich gerade betrachtetem Netzknoten */

                          if ( aktuelle_id == i )
	                  {
                             /** Animation Ausgang zum Zielknoten der Queue j des gerade betrachteten Netzknotens */
                    
                           fenster.Erklaerungen.appendText("data-package "+hilf.gib_id()+" is routed from the actual node to node "+Netzwerk[i].gib_queue(j).gib_zielknoten().gib_id()+"\n");
                           anim_ausgang(i,j);
	                  }  // if      

                         /** Falls aktueller Netzknoten gleich Zielknoten der Queue j */ 
                          if ( aktuelle_id == Netzwerk[i].gib_queue(j).gib_zielknoten().gib_id() )
                          {
                             /** Animation Eingang im Zielknoten der Queue j */

                             fenster.Erklaerungen.appendText("data-package "+hilf.gib_id()+" reached node "+Netzwerk[i].gib_queue(j).gib_zielknoten().gib_id()+" and is routed\n");
                             anim_eingang(Netzwerk[i].gib_queue(j).gib_zielknoten().gib_id(),ziel);
			  } // if

                          /** Datenpaket im Zielknoten der Queue j in die Queue ziel einfuegen */

	           Netzwerk[Netzwerk[i].gib_queue(j).gib_zielknoten().gib_id()].gib_queue(ziel).einfuegen(hilf);
		       } // if
                       aktualisiere_netzknoten();
		      } //if
                    } // if
	     } // for
     /** Pause machen */
      try
       {
          netzwerkthread.sleep(200);
       } // try
      catch ( InterruptedException e ) { System.out.println("network-thread was interrupted"); }
	  } // catch
      /** Alles mal neuzeichnen, um eventuell aufgetretene Fehler durch Verschieben oder Veraendern
          des Fensters  zu beheben */
      repaint(); 
      } // for
  } // Netzwerkdarstellung.run

  /** Ausgangsanimation bei Netzknoten Netzwerk[netzknotenzahl] und der Queue queuezahl */

  public void anim_ausgang(int knotenzahl, int queuezahl)
  {
   int x_anim; 
   int y_anim; 
   int anim_xende;
   int anim_yende;
   int x_center = ( lo.x+ru.x ) / 2;
   int y_center = ( lo.y+ru.y ) / 2;
   Graphics g = this.getGraphics();
   g.setColor(Color.red);

   /** Warten bis das Neuzeichnen beendet ist, um Fehler zu vermeiden */ 

   while ( repaint_laeuft )
   {
     /** Warten */
      try
       {
          netzwerkthread.sleep(10);
       } // try
      catch (InterruptedException e ) 
        { } // catch     
    } // while

   animation_laeuft = true;
 
   /** Falls Ausgangsanimation des Zielknotens */

   if ( knotenzahl == zielknoten && queuezahl == -1 )
    {
      x_anim = qb;
      y_anim = y_center - ( anim_dicke / 2);
      anim_xende = ru.x-((3*qb)/2);
      g.setColor(Color.red);
      g.setXORMode(this.getBackground());

      /** Position des Datenpakets zwischenspeichern zwecks Fehlerbehebung ( siehe paint-Methode ) */

      anim_punkt.x = x_anim;
      anim_punkt.y = y_anim;
   
      /** Datenpaket zeichnen */

      g.fillRect(x_anim,y_anim,anim_dicke,anim_dicke);
      mainapplet.getToolkit().sync();
      while( x_anim <= anim_xende )
        { 
          // g.setXORMode(this.getBackground());      ???
          
          /** Datenpaket loeschen */

          g.fillRect(x_anim,y_anim,anim_dicke,anim_dicke);
          mainapplet.getToolkit().sync();
          x_anim +=(anim_dicke+2);

           /** Position des Datenpakets zwischenspeichern zwecks Fehlerbehebung ( siehe paint-Methode ) */

          anim_punkt.x = x_anim;
          anim_punkt.y = y_anim;

          /** Datenpaket an neuer Stelle zeichenen */

          g.fillRect(x_anim,y_anim,anim_dicke,anim_dicke);
          mainapplet.getToolkit().sync();
 
          /** Warten */

          try
          {
            netzwerkthread.sleep(anim_delay);
	  } // try
          catch ( InterruptedException e) {} // catch
    
          /** Falls Animationsunterbrechung von aussen erwuenscht, Animations-Schleife verlassen */

          if ( animation_ende )
          {
            animation_ende = false;
            break;
          } // if
        } // while

     /** Letztes Datenpaket loeschen */

      g.fillRect(x_anim,y_anim,anim_dicke,anim_dicke);
      mainapplet.getToolkit().sync();
      animation_laeuft = false;
     }
  else /** allgemeine Ausgangsanimation */
    {
      int aus_zaehler = 0;
      int xo_anim;
      int yo_anim;
      int x_abschnitt;
      int y_abschnitt;
      int abschnitte = 20;
      int xo_op;
      int yo_op;
      Point p_von;
      Point p_zu;
      int ziel_id;
      int hilfx = breite/2;
      int hilfy = hoehe/2;

      animation_laeuft = true;
      anim_oben_laeuft = true;      

      /** Berechnungen fuer die Animation im Netzwerk */

      p_von = new Point(Netzwerk[knotenzahl].gib_x()-(anim_dicke/2)+hilfx,Netzwerk[aktuelle_id].gib_y()+hilfy-(anim_dicke/2));
      ziel_id = Netzwerk[knotenzahl].gib_queue(queuezahl).gib_zielknoten().gib_id();
      p_zu = new Point(Netzwerk[ziel_id].gib_x()+hilfx-(anim_dicke/2),Netzwerk[ziel_id].gib_y()+hilfy-(anim_dicke/2));
      if ( p_zu.x <= p_von.x )
        xo_op = -1;
      else   
        xo_op =+1; // if
      if ( p_zu.y <= p_von.y )
        yo_op=-1;
      else
        yo_op=+1; // if
      x_abschnitt = (int) (Math.abs(p_von.x - p_zu.x)/abschnitte);
      y_abschnitt = (int) (Math.abs(p_von.y - p_zu.y)/abschnitte);
      xo_anim = p_von.x;
      yo_anim = p_von.y;

      /** Berechnungen fuer die Animation des aktuellen Knotens */

      int yop=0;
      x_anim = Netzwerk[knotenzahl].gib_queue(queuezahl).gib_xpos();
      y_anim = Netzwerk[knotenzahl].gib_queue(queuezahl).gib_ypos();
      if ( y_anim <= y_center )
           yop = -1;
       else
	   yop = +1; // if
      y_anim += yop*(int)(qh/2);
     if ( yop == -1 )
      {
         y_anim +=(int) (qh/2);
      } // if
      x_anim += (int) (qb/3);

      /** Animation beginnen */

      g.setColor(Color.red);
      g.setXORMode(this.getBackground());

      /** obere Animation */
   
      /** Position des Datenpakets zwischenspeichern zwecks Fehlerbehebung ( siehe paint-Methode ) */

      anim_oben.x = xo_anim;
      anim_oben.y = yo_anim;

      /** Datenpaket zeichnen  */

      g.fillOval(xo_anim, yo_anim,anim_dicke,anim_dicke);
      mainapplet.getToolkit().sync();

      /** untere Animation */

      /** Position des Datenpakets zwischenspeichern zwecks Fehlerbehebung ( siehe paint-Methode ) */

      anim_punkt.x = x_anim;
      anim_punkt.y = y_anim;

      /** Datenpaket zeichnen */

      g.fillRect(x_anim, y_anim,anim_dicke,anim_dicke);
      mainapplet.getToolkit().sync(); 

      for (int i = 0; i < abschnitte ; i++)
       { 
          /** Animation des Datenpakets von Knoten zu Knoten */

          /** Datenpaket loeschen */

          g.fillOval(xo_anim,yo_anim,anim_dicke,anim_dicke);
          mainapplet.getToolkit().sync();

          xo_anim += xo_op*x_abschnitt;
          yo_anim += yo_op*y_abschnitt;

          /** Position des Datenpakets zwischenspeichern zwecks Fehlerbehebung ( siehe paint-Methode ) */

          anim_oben.x = xo_anim;
          anim_oben.y = yo_anim;
       
         /** Datenpaket zeichnen */

          g.fillOval(xo_anim,yo_anim,anim_dicke,anim_dicke);
          mainapplet.getToolkit().sync();

          /** Animation des Datenpakets im aktuellen Knoten alle 5 Durchlaeufe */

          if ( aus_zaehler == 5 )      
          { 

           /** Datenpaket loeschen */

            g.fillRect(x_anim, y_anim,anim_dicke,anim_dicke);
            mainapplet.getToolkit().sync();

            y_anim +=yop*(anim_dicke+2);

            /** Position des Datenpakets zwischenspeichern zwecks Fehlerbehebung ( siehe paint-Methode ) */

            anim_punkt.x = x_anim;
            anim_punkt.y = y_anim;

            /** Datenpaket zeichnen */

            g.fillRect(x_anim, y_anim,anim_dicke,anim_dicke);
            mainapplet.getToolkit().sync();
            aus_zaehler = 0;
	  } // if

          /** Pause machen */
          try
          {
            netzwerkthread.sleep((anim_delay));
	  } // try
          catch ( InterruptedException e) {} // catch 
          aus_zaehler++;

          /** Falls Animationsunterbrechung von aussen erwuenscht, Animations-Schleife verlassen */

          if ( animation_ende )
          {
            animation_ende = false;
            break;
          } // if
       } // for

      /** Datenpakete loeschen */

      g.fillRect(x_anim, y_anim,anim_dicke,anim_dicke);
      g.fillOval(xo_anim, yo_anim,anim_dicke,anim_dicke);
      mainapplet.getToolkit().sync();
    } // if
    g.setXORMode(this.getBackground());
    animation_laeuft = false;
    anim_oben_laeuft = false;

    /** dem AWT Zeit zu zeichnen lassen */
    try
          {
            netzwerkthread.sleep(5*anim_delay);
	  } // try
          catch ( InterruptedException e) {} // catch

  }// Netzwerkdarstellung.anim_ausgang

  /** Animation Eingang Netzknoten Netzwerk[t] in Queue queuezahl */

  public void anim_eingang(int knotenzahl, int queuezahl)
  {
    int x_anim; 
    int y_anim; 
    int anim_xende;
    int anim_yende;
    int xop = 0;
    int yop = 0;
    int abschnitte;
    int x_abschnitt;
    int y_abschnitt;

    /** Warten bis Neuzeichnen beendet */

    while ( repaint_laeuft )
    {
      /** Warten */
      try
       {
          netzwerkthread.sleep(10);
       } // try
      catch (InterruptedException e ) 
        { } // catch      
      } // while

    int  x_center = ( lo.x+ru.x ) / 2;
    int y_center = ( lo.y+ru.y) / 2;
    Graphics g = this.getGraphics();
    x_anim = lo.x;
    y_anim = y_center - (anim_dicke /2);
    anim_xende = x_center;
    animation_laeuft = true;

    /** Teil 1 : Animation von rechts in den aktuellen Netzknoten hinein */

    g.setColor(Color.red);
    g.setXORMode(this.getBackground());

    /** Position des Datenpakets zwischenspeichern zwecks Fehlerbehebung ( siehe paint-Methode ) */

    anim_punkt.x = x_anim;
    anim_punkt.y = y_anim;

    /** Datenpaket zeichnen */

    g.fillRect(x_anim,y_anim,anim_dicke,anim_dicke);
    mainapplet.getToolkit().sync();

    while( x_anim <= anim_xende )
      { 
        /** Datenpaket loeschen */

        g.fillRect(x_anim,y_anim,anim_dicke,anim_dicke);
        mainapplet.getToolkit().sync();

        x_anim +=(anim_dicke+2);

        /** Position des Datenpakets zwischenspeichern zwecks Fehlerbehebung ( siehe paint-Methode ) */

        anim_punkt.x = x_anim;
        anim_punkt.y = y_anim;

        /** Datenpaket zeichnen */

        g.fillRect(x_anim,y_anim,anim_dicke,anim_dicke);
        mainapplet.getToolkit().sync();

        /** Falls Animationsunterbrechung von aussen erwuenscht, Animations-Schleife verlassen */
        
        if ( animation_ende )
          {
            break;
          } // if
        try
        {
          netzwerkthread.sleep(anim_delay);
	} // try
        catch ( InterruptedException e) {} // catch
        
      } // while

    /** Datenpaket loeschen */

    g.fillRect(x_anim,y_anim,anim_dicke,anim_dicke);
    mainapplet.getToolkit().sync();

    /** Teil 2 : Animation zur entsprechenenden Queue */

    anim_xende = Netzwerk[knotenzahl].gib_queue(queuezahl).gib_xpos();
    anim_yende = Netzwerk[knotenzahl].gib_queue(queuezahl).gib_ypos();
    abschnitte =(int)  ((Math.sqrt(Math.pow((x_center -anim_xende),2)+Math.pow((y_center-anim_yende),2)))/(anim_dicke+2));
     x_abschnitt = (int) (Math.abs(x_center - anim_xende)/abschnitte);
    if ( x_abschnitt == 0 )
      {  x_abschnitt = 1; } // if
    y_abschnitt = (int) (Math.abs(y_center - anim_yende)/abschnitte);
    if ( y_abschnitt <= 1)
      { y_abschnitt = 1; } // if
    if ( anim_xende <= x_center )
         xop = -1;
    else   
      xop =+1; // if
     if ( anim_yende <= y_center )
        yop=-1;
     else
       {
         yop=+1;
         y_abschnitt +=1;
       } // if

    /** Position des Datenpakets zwischenspeichern zwecks Fehlerbehebung ( siehe paint-Methode ) */

    anim_punkt.x = x_anim;
    anim_punkt.y = y_anim;

    /** Datenpaket zeichnen */

    g.fillRect(x_anim,y_anim,anim_dicke,anim_dicke);
    mainapplet.getToolkit().sync();

    for ( int i=0; i < abschnitte; i++)
    {
      /** Datenpaket loeschen */

      g.fillRect(x_anim,y_anim,anim_dicke,anim_dicke);
      mainapplet.getToolkit().sync();

      x_anim += xop*x_abschnitt;
      y_anim += yop*y_abschnitt;

      /** Position des Datenpakets zwischenspeichern zwecks Fehlerbehebung ( siehe paint-Methode ) */

      anim_punkt.x = x_anim;
      anim_punkt.y = y_anim;

      /** Datenpaket zeichnen */

      g.fillRect(x_anim,y_anim,anim_dicke,anim_dicke);
      mainapplet.getToolkit().sync();

      /** Warten */
     
      try
       {
          netzwerkthread.sleep(anim_delay);
       } // try
      catch (InterruptedException e ) 
        { } // catch

       /** Falls Animationsunterbrechung von aussen erwuenscht, Animations-Schleife verlassen */

       if ( animation_ende )
          {
            animation_ende = false;
	    break;
          } // if
    } // for

   /** Datenpaket loeschen */

   g.fillRect(x_anim,y_anim,anim_dicke,anim_dicke);
   mainapplet.getToolkit().sync();
   g.setXORMode(this.getBackground());
   animation_laeuft = false;	  
   /** dem AWT Zeit zu zeichnen lassen */
    try
          {
            netzwerkthread.sleep(5*anim_delay);
	  } // try
          catch ( InterruptedException e) {} // catch
    
  } // Netzwerkdarstellung.anim_eingang

  /** Wird die Anmation durch den Stop-Button  beendet, bleiben die zuletzt gezeichnten Datenpakete stehen,
         deshalb muessen sie nachtraeglich geloescht werden */

  public void loesche_datenpaket()
  {
     Graphics g = this.getGraphics();
     g.setXORMode(this.getBackground());
     g.setColor(Color.red);
     if ( animation_laeuft )
       g.fillRect(anim_punkt.x,anim_punkt.y,anim_dicke,anim_dicke); // if
     if ( anim_oben_laeuft )
       g.fillOval(anim_oben.x,anim_oben.y,anim_dicke,anim_dicke); // if
     animation_laeuft = false;
     anim_oben_laeuft = false;
  } // Netzwerkdarstellung.loesche_datenpaket

} // Netzwerkdarstellung




