/** 
 * @(#)Oberflaeche.java
 */

/**
 * @author Didier Gutacker
 * @version 1.0, 12.08.97
 * @see NetzwerkCanvas
 * @see HotPotato 
 */

import java.awt.*;
import java.applet.*;

public class Oberflaeche extends Frame
{
  /** Threadobjekt */

  private HotPotato mainapplet; 

  /** Oberflaechenobjekte */

  /** Netzwerkuebersichtsdarstellungsobjekt */

  Netzwerkdarstellung NetzwerkCanvas;  

  /** Textfeld Erklaerungen */

  TextArea Erklaerungen = new TextArea(5,75);

  /** Schalter Start, Stop, Ende, Demo, Hilfe, Weiter, Sprache */

  Button ende = new Button("End");
  Button startstop = new Button("Start");
  Button sknoten = new Button("Start-node");
  Button zknoten = new Button("Aim-node");
  Button hilfe = new Button("Help");
  Button neu = new Button("New");
  Button effelsberg = new Button("Effelsberg-Demo");
  Button queuerate = new Button("Queue-rate");
  
  /** Bildschirmeinteilungspanel */

  Panel Statuszeile = new Panel();
  Panel Schalter = new Panel();

  /** Oberflaeche aufbauen */

  public Oberflaeche(HotPotato m)
   {

    /** Fenstermenues */
    
    MenuBar mbar = new MenuBar();

    Menu mpr = new Menu("Program");
    mpr.add(new MenuItem("End"));
    mbar.add(mpr);

    Menu mopt = new Menu ("Options");
    mopt.add(new MenuItem("Animationspeed"));
    mopt.addSeparator();
    mopt.add(new MenuItem("Queue-rate"));
    mopt.addSeparator();
    mopt.add(new MenuItem("Speech-support"));
    mbar.add(mopt);

    Menu mhelp = new Menu("Help");
    mhelp.add(new MenuItem("About"));
    mhelp.addSeparator();
    mhelp.add(new MenuItem("Help"));
    mbar.add(mhelp);

    setMenuBar(mbar);

    /** Uebergebene Variable auslesen */

    mainapplet = m;

    /** Referenz auf die Instanz der Appletklasse  uebergeben, um das Problem mit Resume und Suspend zu umgehen */

   NetzwerkCanvas = new Netzwerkdarstellung(this,mainapplet);

    /** Titel : HotPotato-Routing */

    setTitle("HotPotato-Routing");
   
    /** Schaltflaechen */

    Schalter.setLayout( new GridLayout(8,1,10,10) );
    Schalter.add( neu );
    Schalter.add( effelsberg );
    Schalter.add( startstop );
    Schalter.add( hilfe );
    Schalter.add( sknoten );
    Schalter.add( zknoten );
    Schalter.add( queuerate );
    Schalter.add( ende );
 
    /** Textausgabe ... */

    Erklaerungen.setEditable(false);
    Erklaerungen.setBackground(Color.white);

   
    /** Aufbau der Oberflaeche :  links die Buttonleiste, rechts die Grafikausgabe und unten die Textausgabe */
    
    Statuszeile.setLayout( new FlowLayout() );
    Statuszeile.add(Erklaerungen);

    add("West",Schalter);
    add("Center",NetzwerkCanvas);
    add("South", Statuszeile);
    
    NetzwerkCanvas.berechnungen();
  
   } // Oberflaeche.Oberflaeche

  /**
   *  Setzt die Ausstossraten der Queues zurueck
   */

   public void queuerate_reset()
   {
     sknoten.enable();
     queuerate.enable();
   } // Oberflaeche.queuerate_reset

   public boolean handleEvent(Event evt)
    {
       if (evt.id == Event.WINDOW_DESTROY && evt.target == this)
          {
             this.hide();
             this.dispose();
	  } // if
       if (evt.id == Event.WINDOW_MOVED )
          {
             NetzwerkCanvas.berechnungen();
             NetzwerkCanvas.repaint();
	  } // if
      return super.handleEvent(evt);
     } // Oberflaeche.handleEvent

    public boolean action(Event evt, Object arg)
    {
      if (arg.equals("New")) {
                                NetzwerkCanvas.stop();
                                NetzwerkCanvas.reset();
                                }
      else if (arg.equals("Effelsberg-Demo")) {
                                NetzwerkCanvas.stop();
                                NetzwerkCanvas.setze_effels();
                                effelsberg.setLabel("Standard-Demo");
                                NetzwerkCanvas.reset();
                 
                                }
      else if (arg.equals("Standard-Demo")) {
                                NetzwerkCanvas.stop();
                                NetzwerkCanvas.setze_standard();
                                effelsberg.setLabel("Effelsberg-Demo");
                                NetzwerkCanvas.reset();                             
                                }
      else if (arg.equals("Start"))
                {
                  if ( NetzwerkCanvas.netzwerkthread == null )
                    NetzwerkCanvas.start();
                  else
                    NetzwerkCanvas.netzwerkthread.resume();
                    startstop.setLabel("Stop");
                    neu.disable();
                    sknoten.disable();
                    zknoten.disable();
                    effelsberg.disable();
                    }
      else if (arg.equals("Stop"))
                {
                    NetzwerkCanvas.netzwerkthread.suspend();
                    startstop.setLabel("Start");
                    neu.enable();
                    sknoten.enable();
                    zknoten.enable();
                    effelsberg.enable();
                    }
      else if (arg.equals("End")){
                                    NetzwerkCanvas.stop();
                                    NetzwerkCanvas.netzwerkthread = null;
                                    NetzwerkCanvas.loesche_datenpaket();
                                    this.dispose();
                                    }
      else if (arg.equals("Help")) {
                                       if ( startstop.getLabel() == "Start" )
                                       {
                                         Hilfe Hilfefenster = new Hilfe();
                                         Hilfefenster.pack();
                                         Hilfefenster.resize(620,450);
                                         Hilfefenster.show();
                                         }
                                       }
      else if (arg.equals("About")) {
                                        if ( startstop.getLabel() == "Start" )
                                        {
                                         About Aboutfenster = new About(this);
                                         Aboutfenster.pack();
                                         Aboutfenster.resize(300,300);
                                         Aboutfenster.show();
                                         }
                                       }
      else if (arg.equals("Animationspeed")) {               
            SpeedSelect s = new SpeedSelect(this);
             s.pack();
             s.show();
         }
       else if (arg.equals("Queue-rate")) {       
             sknoten.disable();
             queuerate.disable();       
             Ausstoss a = new Ausstoss(this,NetzwerkCanvas.gib_akt_knoten());
             a.pack();
             a.resize(500,400);
             a.show();
         }                     
     else if (arg.equals("Start-node")) {
                                       NetzwerkCanvas.setze_sflag();
                                       zknoten.disable();
                                       }                           
       else if (arg.equals("Aim-node")) {
                                       NetzwerkCanvas.setze_zflag();
                                       sknoten.disable();
                                       }                                       
      else return false;

      return true;
   } // Oberflaeche.action
 
} // Oberflaeche


