/** 
 * @(#)SpeedSelect.java
 */

/**
 * @author Axel ...?
 * @version 1.1, 12.08.97 
 */

/**
 * original author Axel ... ?, changes by Didier Gutacker
 */

import java.awt.*;
import java.applet.*;

class SpeedSelect extends Frame {
   private Label currentSpeed;
   private int sleepTime;
   private Scrollbar speed;
   private Button ok,cancel;
   private Font font = new Font("Dialog",Font.BOLD,15);
   private Oberflaeche puCl;

   /** Konstruktur. Baut neues Fenster mit Scrollbar zur Wahl der Geschwindigkeit auf*/

   public SpeedSelect(Oberflaeche publicClass) {
      puCl = publicClass;
      sleepTime = puCl.NetzwerkCanvas.anim_delay;
      setTitle("Animationsgeschwindigkeit regulieren");
      Panel label = new Panel();
      label.setLayout(new BorderLayout());
      label.add("Center",currentSpeed = new Label("Pause zwischen Bewegungen (Tsd.Sec) : "+sleepTime+"    "));
      Panel scrollbar = new Panel();
      scrollbar.setLayout(new BorderLayout());
      scrollbar.add("Center",speed = new Scrollbar(Scrollbar.HORIZONTAL,1,1,10,1000));
      speed.setPageIncrement(5);
      speed.setLineIncrement(1);
      speed.setValue(sleepTime);
      Panel button = new Panel();
      button.setLayout(new FlowLayout());
      button.add(ok = new Button("Ok"));
      button.add(cancel = new Button ("Cancel"));
      this.setLayout(new BorderLayout());
      this.setFont(font);
      add("North",label);
      add("Center",scrollbar);
      add("South",button);
   } // SpeedSelect.SpeedSelect


   public boolean handleEvent(Event evt) {
      if (evt.id == Event.WINDOW_DESTROY&& evt.target == this) {
         this.hide();
         this.dispose();
      }
      else if (   evt.id ==Event.SCROLL_ABSOLUTE
               || evt.id ==Event.SCROLL_LINE_DOWN
               || evt.id ==Event.SCROLL_LINE_UP
               || evt.id ==Event.SCROLL_PAGE_DOWN
               || evt.id ==Event.SCROLL_PAGE_UP) {
         currentSpeed.setText("Pause zwischen Bewegungen (Tsd.Sec.) : "+speed.getValue()+"     ");
         return true;
      }
      else if(evt.target == ok) {
         puCl.NetzwerkCanvas.anim_delay = speed.getValue();
         this.hide();
         this.dispose();
         return true;
      }
      else if(evt.target == cancel) {
         this.hide();
         this.dispose();
         return true;
      }      
      return super.handleEvent(evt);
   } // SpeedSelect.handleEvent

} // SpeedSelect

