/** 
 * @(#)Warteschlange.java
 */

/**
 * @author Didier Gutacker
 * @version 1.0, 12.08.97 
 * @see Link
 * @see Netzknoten
 */

/**
 * Die Klasse Warteschlange ist eine Implemenation einer FIFO-Schlange, d.h. das Datenpakete am Ende
 * angefuegt und am Anfang entnommen werden.
 */

class Warteschlange
{
  private Netzknoten zielknoten;
  private int xpos;
  private int ypos;
  private Link head;
  private Link tail;
  private Link aktuell;
  private int anzahldp;
  
  /**
   * Setzt die x-Koordinate der Warteschlange in der Detailansicht des aktuellen Knotens
   */

  public void setze_xpos(int  temp)
  {
     xpos = temp;
  } // Warteschlange.setze_xpos

  /**
   * Gibt die x-Koordinate der Warteschlange in der Detailansicht des aktuellen Knotens zurueck
   */

  public int gib_xpos()
  {
    return(xpos);
  } // Warteschlange.gib_xpos

  /**
   * Setzt die a-Koordinate der Warteschlange in der Detailansicht des aktuellen Knotens
   */

  public void setze_ypos(int  temp)
  {
     ypos = temp;
  } // Warteschlange.setze_ypos

  /**
   * Gibt die y-Koordinate der Warteschlange in der Detailansicht des aktuellen Knotens zurueck
   */

  public int gib_ypos()
  {
    return(ypos);
  } // Warteschlange.gib_ypos

  /**
   * Fuegt ein Datenpaket am Ende der Warteschlange ein
   */

  public void einfuegen(Datenpaket tp)
    { 
      aktuell = new Link(tp,null);
      if ( head == null )
       {
        head = aktuell;
        tail = head;
       }
      else
       {
         tail.next = aktuell;
         tail = aktuell;
       } // if
      anzahldp++;
    } // Warteschlange.einfuegen 

  /**
   * Holt und loescht das Datenpaket am Anfang der Warteschlange 
   */

  public Datenpaket holen()
   {
     Datenpaket temp;  
     aktuell = head;
     head = head.next;
     temp = aktuell.data;
     aktuell = null;
     anzahldp--;
     return(temp); 
    } // Warteschlange.holen

  public int groesse()
   {
    return(anzahldp);
   } // Warteschlange.groesse

  public void setze_zielknoten(Netzknoten temp)
  {
   zielknoten = temp;
  } // Warteschlange.setze_zielknoten

  public Netzknoten gib_zielknoten()
  {
    return(zielknoten);
  } // Warteschlange.gib_zielknoten

} // Warteschlange
   



